## net.sf.saxon.expr
Class AxisExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.AxisExpression

All Implemented Interfaces:
  java.io.Serializable, javax.xml.transform.SourceLocator, LocationProvider, SaxonLocator, EvaluableItem, SequenceIterable, InstructionInfo, org.xml.sax.Locator

    public final class AxisExpression

extends Expression

An AxisExpression is always obtained by simplifying a PathExpression. It represents a PathExpression that starts at the context node, and uses a simple node-test with no filters. For example "*", "title", "./item", "@*", or "ancestor::chapter*".

An AxisExpression delivers nodes in axis order (not in document order). To get nodes in document order, in the case of a reverse axis, the expression should be wrapped in a call on reverse().

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, staticProperties`

Constructor Summary
`AxisExpression(byte axis, NodeTest nodeTest)` Constructor

Method Summary
`PathMap.PathMapNodeSet` `addToPathMap(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` Add a representation of this expression to a PathMap.
`int` `computeCardinality()` Specify that the expression returns a singleton
`int` `computeSpecialProperties()` Get the static properties of this expression (other than its type).
`Expression` `copy()` Copy an expression.
`boolean` `equals(java.lang.Object other)` Is this expression the same as another expression?
`void` `explain(ExpressionPresenter destination)` Diagnostic print of expression structure.
`byte` `getAxis()` Get the axis
`ItemType` `getContextItemType()` Get the static type of the context item for this AxisExpression.
`int` `getIntrinsicDependencies()` Determine which aspects of the context the expression depends on.
`ItemType` `getItemType(TypeHierarchy th)` Determine the data type of the items returned by this expression
`NodeTest` `getNodeTest()` Get the NodeTest.
`int` `hashCode()` get HashCode for comparing two expressions
`SequenceIterator` `iterate(Item origin)` Iterate the axis from a given starting node, without regard to context
`SequenceIterator` `iterate(XPathContext context)` Evaluate the path-expression in a given context to return a NodeSet
`Expression` `optimize(ExpressionVisitor visitor, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`Expression` `simplify(ExpressionVisitor visitor)` Simplify an expression
`java.lang.String` `toString()` Represent the expression as a string for diagnostics
`java.lang.String` `toString(NamePool pool)` Represent the expression as a string for diagnostics
`Expression` `typeCheck(ExpressionVisitor visitor, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.Expression

`adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, display, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, evaluatePendingUpdates, explain, findParentOf, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isUpdatingExpression, iterateEvents, iterateSubExpressions, markTailFunctionCalls, process, promote, replaceSubExpression, resetLocalStaticProperties, setContainer, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### AxisExpression

    public AxisExpression(byte axis,
                          NodeTest nodeTest)

  Constructor

  Parameters:
    `axis` - The axis to be used in this AxisExpression: relevant constants are defined in class net.sf.saxon.om.Axis.
    `nodeTest` - The conditions to be satisfied by selected nodes. May be null, indicating that any node on the axis is acceptable
  See Also:
    `Axis`

Method Detail

### simplify

    public Expression simplify(ExpressionVisitor visitor)

  Simplify an expression

  Overrides:
    `simplify` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
  Returns:
    the simplified expression

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### getContextItemType

    public ItemType getContextItemType()

  Get the static type of the context item for this AxisExpression. May be null if not known.

  Returns:
    the statically-inferred type, or null if not known

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ItemType contextItemType)

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution

### equals

    public boolean equals(java.lang.Object other)

  Is this expression the same as another expression?

  Overrides:
    `equals` in class `java.lang.Object`

### hashCode

    public int hashCode()

  get HashCode for comparing two expressions

  Overrides:
    `hashCode` in class `java.lang.Object`

### getIntrinsicDependencies

    public int getIntrinsicDependencies()

  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE

  Overrides:
    `getIntrinsicDependencies` in class `Expression`
  Returns:
    a set of bit-significant flags identifying the "intrinsic" dependencies. The flags are documented in class net.sf.saxon.value.StaticProperty

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### computeSpecialProperties

    public int computeSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeSpecialProperties` in class `Expression`
  Returns:
    the special properties, as a bit-significant integer

### getItemType

    public final ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items returned by this expression

  Specified by:
    `getItemType` in class `Expression`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    Type.NODE or a subtype, based on the NodeTest in the axis step, plus information about the content type if this is known from schema analysis

### computeCardinality

    public final int computeCardinality()

  Specify that the expression returns a singleton

  Specified by:
    `computeCardinality` in class `Expression`
  Returns:
    the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

### getAxis

    public byte getAxis()

  Get the axis

  Returns:
    the axis number, for example `Axis.CHILD`

### getNodeTest

    public NodeTest getNodeTest()

  Get the NodeTest. Returns null if the AxisExpression can return any node.

  Returns:
    the node test, or null if all nodes are returned

### addToPathMap

    public PathMap.PathMapNodeSet addToPathMap(PathMap pathMap,
                                               PathMap.PathMapNodeSet pathMapNodeSet)

  Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.

  Overrides:
    `addToPathMap` in class `Expression`
  Parameters:
    `pathMap` - the PathMap to which the expression should be added
    `pathMapNodeSet` -
  Returns:
    the pathMapNode representing the focus established by this expression, in the case where this expression is the first operand of a path expression or filter expression

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Evaluate the path-expression in a given context to return a NodeSet

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - the evaluation context
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### iterate

    public SequenceIterator iterate(Item origin)
                             throws XPathException

  Iterate the axis from a given starting node, without regard to context

  Parameters:
    `origin` - the starting node
  Returns:
    the iterator over the axis
  Throws:
    `XPathException`

### explain

    public void explain(ExpressionPresenter destination)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Specified by:
    `explain` in class `Expression`
  Parameters:
    `destination` - the expression presenter used to display the structure

### toString

    public java.lang.String toString()

  Represent the expression as a string for diagnostics

  Overrides:
    `toString` in class `Expression`

### toString

    public java.lang.String toString(NamePool pool)

  Represent the expression as a string for diagnostics

  Parameters:
    `pool` - the name pool, used for expanding names in the node test
  Returns:
    a string representation of the expression

Copyright (c) Saxonica Limited. All rights reserved.